<?php

	define('APS_DEVELOPMENT_MODE', true);
	require "aps/2/runtime.php";	

	class CPU {
		/**
		 * @type("integer")
		 * @title("Number of CPUs")
		 * @description("Number of CPU cores")
		 */
		public $number;
	}
	
	class OS {
		/**
		 * @type("string")
		 * @title("OS Name")
		 * @description("Operating System Name")
		 */
		public $name;
	
		/**
		 * @type("string")
		 * @title("OS Version")
		 * @description("Operating System version")
		 */
		public $version;
	}
	
	class Hardware {
		/**
		 * @type("integer")
		 * @title("RAM Size")
		 * @description("RAM size in GB")
		 */
		public $memory;
	
		/**
		 * @type("integer")
		 * @title("Disk Space")
		 * @description("Disk space in GB")
		 */
		public $diskspace;
	
		/**
		 * @type("CPU")
		 * @title("CPU")
		 * @description("Server CPU parameters")
		 */
		public $CPU;
	}
	
	class Platform {
		/**
		 * @type("string")
		 * @title("Architecture")
		 * @description("Platform architecture")
		 */
		public $arch;
	
		/**
		 * @type("OS")
		 * @title("OS Parameters")
		 * @description("Parameters of operating system")
		 */
		public $OS;
	}
	
	/**
	* @type("http://aps-standard.org/samples/offer1p/vps/1.0")
	* @implements("http://aps-standard.org/types/core/resource/1.0")
	*/

	class vps extends \APS\ResourceBase
	{

		/**
		 * @link("http://aps-standard.org/samples/offer1p/context/1.0")
		 * @required
		*/
		public $context;
		
		/**
		 * @link("http://aps-standard.org/samples/offer1p/offer/1.0")
		 * @required
		 */
		public $offer;

		/**
		 * @type("string")
		 * @title("name")
		 * @description("Server Name")
		 */
		public $name;
		
		/**
		 * @type("string")
		 * @title("Description")
		 * @description("Server Description")
		 */
		public $description;
		
		/**
		 * @type("string")
		 * @title("state")
		 * @description("Server State")
		 */
		public $state;
		
		/**
		 * @type("Hardware")
		 * @title("Hardware")
		 * @description("Server Hardware")
		 */
		public $hardware;
		
		/**
		 * @type("Platform")
		 * @title("Platform")
		 * @description("OS Platform")
		 */
		public $platform;
		
		/**
		 * @verb(GET)
		 * @path("/start")
		 * @return(string,text/json)
		 */
		public function start() {
			$this->state = 'Running';
			$apsc = \APS\Request::getController();
			$apsc->updateResource($this);
		}
		
		/**
		 * @verb(GET)
		 * @path("/stop")
		 * @return(string,text/json)
		 */
		public function stop() {
			$this->state = 'Stopped';
			$apsc = \APS\Request::getController();
			$apsc->updateResource($this);
		}
	}

?>
